//////////////////////////////////////////////////////////////
//                                                          //
// MyChat Client SDK, version 0.1 from 08.11.2009           //
// Copyright(c) Alexey Pikurov / Network Software Solutions //
// hobit@nsoft-s.com                                        //
// http://www.nsoft-s.com                                   //
//                                                          //
//////////////////////////////////////////////////////////////
//                                                          //
//                  !                     //
//                                                          //
//////////////////////////////////////////////////////////////
unit mcplugin_func;

interface
uses Windows;
const
  pluginAPIVersionMajor = 1;
  pluginAPIVersionMinor = 0;
  CRLF=#13#10;
  terminator=#149; // -

type
//    . uid -   , msg -  
  TmcSendMessageToTextChannel = procedure(uid:dword;msg:PChar);stdcall;
//    , uin - , msg -   
  TmcSendPrivateMessage       = procedure(uin:dword;msg:PChar);stdcall;
//   , ..   ,    
// uin - , uid -  , msg -  
  TmcSendPersonalMessage      = procedure(uin,uid:dword;msg:PChar);stdcall;
//    , ..   ,    
//         
// uin - , uid -  , msg -  
  TmcSendAlertMessage         = procedure(uin,uid:dword;msg:PChar);stdcall;
//   .            
// uid -  , topic -   
  TmcChangeTextChannelTopic   = procedure(uid:dword;topic:PChar);stdcall;
//   ().
// uin -    ,
// uid -  ,     ,
// bantime -  : 1 - 5 , 2 - 15 , 3 - , 4-  , 5 - , 6 - , 7 - , 8 - ;
// bantype -  : 0 -     , 1 -     ("");
// reason -  .
//          
  TmcAdmBanUser               = procedure(uin, uid, bantime, bantype:dword;reason:PChar);stdcall;
//    , uin -  , uid -  .
//             
  TmcAdmKickUser              = procedure(uin, uid:dword);stdcall;
//    . uin -  .
//        
  TmcAdmKillUser              = procedure(uin:dword);stdcall;
//  IP  . uin -  .
//      IP  
  TmcAdmBlockIP               = procedure(uin:dword;reason:PChar);stdcall;
//  MAC    . uin -  
//      MAC  
  TmcAdmBlockMAC              = procedure(uin:dword;reason:PChar);stdcall;
//       .   
//  .        
//     MyChat    .
//  -      -,
//      
//   : mcSendRawData(10,'PluginName'+terminator+'test message');
// PluginName -  ,   .     ,
//   " ". terminator - -,  ,   const.
// "test message" -  ,    
  TmcSendRawData              = procedure(uin:dword;msg:PChar);stdcall;
// ,  mcSendRawData,   -    , 
//  ,       uid
  TmcSendRawDataToChannel     = procedure(uid:dword;msg:PChar);stdcall;
//    .     :
// n_groups#group_1#n_users#user_1#user_2#....user_n#group_2#.........
// n_groups -  ,
// # - ,  terminator,
// n_users -     ,
// user_x -   ,  : uin#online#avatar#nick#sex#
// uin -  , ,
// online -        ,  - 1,  0,
// avatar -   ,
// nick -  ,
// sex -  :  - 1,  - 2,   - 0,
// # - ,  terminator
//     -    
// P.S.      get_next_st
  TmcGetContactsList          = function:PChar;stdcall;
  TmcGetChannelUsersList      = function(uid:dword):PChar;stdcall;
  TmcGetChannelsList          = function:PChar;stdcall;
var
  mcSendMessageToTextChannel : TmcSendMessageToTextChannel;
  mcSendPrivateMessage       : TmcSendPrivateMessage;
  mcSendPersonalMessage      : TmcSendPersonalMessage;
  mcSendAlertMessage         : TmcSendAlertMessage;
  mcChangeTextChannelTopic   : TmcChangeTextChannelTopic;
  mcAdmBanUser               : TmcAdmBanUser;
  mcAdmKickUser              : TmcAdmKickUser;
  mcAdmKillUser              : TmcAdmKillUser;
  mcAdmBlockIP               : TmcAdmBlockIP;
  mcAdmBlockMAC              : TmcAdmBlockMAC;
  mcSendRawData              : TmcSendRawData;
  mcSendRawDataToChannel     : TmcSendRawDataToChannel;
  mcGetContactsList          : TmcGetContactsList;
  mcGetChannelUsersList      : TmcGetChannelUsersList;
  mcGetChannelsList          : TmcGetChannelsList;

//      ,   ,  
function get_next_st(var st_parse:string;divide_st:string):string;
function mcPluginName:PChar;stdcall;
function mcPluginCopyright:PChar;stdcall;
procedure mcPluginAPIVersionUsed(var vmajor, vminor:dword);stdcall;
function mcPluginVersion:PChar;stdcall;
function mcPluginReleaseDate:PChar;stdcall;
function mcPluginIsOptionsPresent:dword;stdcall;
function mcPluginIsWindowPresent:dword;stdcall;
function mcPluginIsPopupMenuContactsPanelPresent:dword;stdcall;
function mcPluginIsPopupMenuUserInChannelTextPresent:dword;stdcall;
function mcPluginIsPopupMenuUserInChannelUsersListPresent:dword;stdcall;
function mcPluginIsPopupMenuPrivatePresent:dword;stdcall;

function mcPluginWWW:PChar;stdcall;
function mcPluginEmail:PChar;stdcall;
function mcPluginDescription:PChar;stdcall;
procedure SetCallBackSendMessageToTextChannel(approc:TmcSendMessageToTextChannel);stdcall;
procedure SetCallBackSendPrivateMessage(approc:TmcSendPrivateMessage);stdcall;
procedure SetCallBackSendPersonalMessage(approc:TmcSendPersonalMessage);stdcall;
procedure SetCallBackSendAlertMessage(approc:TmcSendAlertMessage);stdcall;
procedure SetCallBackChangeTextChannelTopic(approc:TmcChangeTextChannelTopic);stdcall;
procedure SetCallBackAdmBanUser(approc:TmcAdmBanUser);stdcall;
procedure SetCallBackAdmKickUser(approc:TmcAdmKickUser);stdcall;
procedure SetCallBackAdmKillUser(approc:TmcAdmKillUser);stdcall;
procedure SetCallBackAdmBlockIP(approc:TmcAdmBlockIP);stdcall;
procedure SetCallBackAdmBlockMAC(approc:TmcAdmBlockMAC);stdcall;
procedure SetCallBackSendRawData(approc:TmcSendRawData);stdcall;
procedure SetCallBackSendRawDataToChannel(approc:TmcSendRawDataToChannel);stdcall;
procedure SetCallBackGetContactsList(approc:TmcGetContactsList);stdcall;
procedure SetCallBackGetChannelUsersList(approc:TmcGetChannelUsersList);stdcall;
procedure SetCallBackGetChannelsList(approc:TmcGetChannelsList);stdcall;

implementation
uses mcplugin_info;

function get_next_st(var st_parse:string;divide_st:string):string;
var tmp:string;
begin
  if pos(divide_st,st_parse)<>0 then begin
    tmp:=copy(st_parse,1,pos(divide_st,st_parse)-1);
    delete(st_parse,1,pos(divide_st,st_parse)-1+length(divide_st));
  end
  else begin tmp:=st_parse;st_parse:='';end;
  result:=tmp;
end;{get_next_st}

function mcPluginName:PChar;
begin
  Result:=pluginName;
end;

function mcPluginCopyright:PChar;
begin
  Result:=pluginCopyright;
end;

procedure mcPluginAPIVersionUsed(var vmajor, vminor:dword);
begin
  vmajor:=pluginAPIVersionMajor;
  vminor:=pluginAPIVersionMinor;
end;

function mcPluginVersion:PChar;
begin
  Result:=pluginVersion;
end;

function mcPluginReleaseDate:PChar;
begin
  Result:=pluginReleaseDate;
end;

function mcPluginIsOptionsPresent:dword;
begin
  Result:=pluginOptionsPresent;
end;

function mcPluginIsWindowPresent:dword;
begin
  Result:=pluginWindowPresent;
end;

function mcPluginIsPopupMenuContactsPanelPresent:dword;stdcall;
begin
  Result:=pluginPopupMenuContactsPanel;
end;

function mcPluginIsPopupMenuUserInChannelTextPresent:dword;stdcall;
begin
  Result:=pluginPopupMenuUserInChannelText;
end;

function mcPluginIsPopupMenuUserInChannelUsersListPresent:dword;stdcall;
begin
  Result:=pluginPopupMenuUserInChannelUsersList;
end;

function mcPluginIsPopupMenuPrivatePresent:dword;stdcall;
begin
  Result:=pluginPopupMenuPrivate;
end;

function mcPluginWWW:PChar;
begin
  Result:=pluginWWW;
end;

function mcPluginEmail:PChar;
begin
  Result:=pluginEmail;
end;

function mcPluginDescription:PChar;
begin
  Result:=pluginDescription;
end;

procedure SetCallBackSendMessageToTextChannel(approc:TmcSendMessageToTextChannel);
begin
  mcSendMessageToTextChannel:=approc;
end;

procedure SetCallBackSendPrivateMessage(approc:TmcSendPrivateMessage);
begin
  mcSendPrivateMessage:=approc;
end;

procedure SetCallBackSendPersonalMessage(approc:TmcSendPersonalMessage);
begin
  mcSendPersonalMessage:=approc;
end;

procedure SetCallBackSendAlertMessage(approc:TmcSendAlertMessage);
begin
  mcSendAlertMessage:=approc;
end;

procedure SetCallBackChangeTextChannelTopic(approc:TmcChangeTextChannelTopic);
begin
  mcChangeTextChannelTopic:=approc;
end;

procedure SetCallBackAdmBanUser(approc:TmcAdmBanUser);
begin
  mcAdmBanUser:=approc;
end;

procedure SetCallBackAdmKickUser(approc:TmcAdmKickUser);
begin
  mcAdmKickUser:=approc;
end;

procedure SetCallBackAdmKillUser(approc:TmcAdmKillUser);
begin
  mcAdmKillUser:=approc;
end;

procedure SetCallBackAdmBlockIP(approc:TmcAdmBlockIP);
begin
  mcAdmBlockIP:=approc;
end;

procedure SetCallBackAdmBlockMAC(approc:TmcAdmBlockMAC);
begin
  mcAdmBlockMAC:=approc;
end;

procedure SetCallBackSendRawData(approc:TmcSendRawData);
begin
  mcSendRawData:=approc;
end;

procedure SetCallBackSendRawDataToChannel(approc:TmcSendRawDataToChannel);
begin
  mcSendRawDataToChannel:=approc;
end;

procedure SetCallBackGetContactsList(approc:TmcGetContactsList);
begin
  mcGetContactsList:=approc;
end;

procedure SetCallBackGetChannelUsersList(approc:TmcGetChannelUsersList);
begin
  mcGetChannelUsersList:=approc;
end;

procedure SetCallBackGetChannelsList(approc:TmcGetChannelsList);
begin
  mcGetChannelsList:=approc;
end;

exports
  mcPluginName,
  mcPluginCopyright,
  mcPluginAPIVersionUsed,
  mcPluginVersion,
  mcPluginReleaseDate,
  mcPluginIsOptionsPresent,
  mcPluginIsWindowPresent,
  mcPluginIsPopupMenuContactsPanelPresent,
  mcPluginIsPopupMenuUserInChannelTextPresent,
  mcPluginIsPopupMenuUserInChannelUsersListPresent,
  mcPluginIsPopupMenuPrivatePresent,
  mcPluginWWW,
  mcPluginEmail,
  mcPluginDescription,
  mcPluginCopyright,
  SetCallBackSendMessageToTextChannel,
  SetCallBackSendPrivateMessage,
  SetCallBackSendPersonalMessage,
  SetCallBackSendAlertMessage,
  SetCallBackChangeTextChannelTopic,
  SetCallBackAdmBanUser,
  SetCallBackAdmKickUser,
  SetCallBackAdmKillUser,
  SetCallBackAdmBlockIP,
  SetCallBackAdmBlockMAC,
  SetCallBackSendRawData,
  SetCallBackSendRawDataToChannel,
  SetCallBackGetContactsList,
  SetCallBackGetChannelUsersList,
  SetCallBackGetChannelsList;
end.
